(* ftw.ml - general file tree walker
 * Copyright (C) 2000, 2001, 2002, 2003 Ed L. Cashin
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *)
type ftw_ret = Continue | Stop

let rec ftw_x absroot cb root =
  let dirh = Unix.opendir (absroot ^ "/" ^ root)
  and ret = ref Continue in
  try
    while !ret = Continue do
      let e = Unix.readdir dirh in
      if e = "." then
	ret := cb root e
      else if e = ".." then ()		(* skip parent dir *)
      else
	let stat = Unix.lstat (absroot ^ "/" ^ root ^ "/" ^ e) in
	if stat.Unix.st_kind = Unix.S_DIR then
	  ret := ftw_x absroot cb (root ^ "/" ^ e)
	else
	  ret := cb root e
    done;
    Unix.closedir dirh;
    !ret
  with End_of_file ->
    Unix.closedir dirh;
    !ret

let ftw cb root = 
  ftw_x root cb "."
