# install from /data/cashin/opt/foo-x.x.x into /data/cashin/inst
# 
# /*
# oinst - software installation management tool
# Copyright (C) 2000, 2001, 2002 Ed L. Cashin
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# */

me=`basename $0`
pwd=`pwd`
pkg=$1
if test -z "$pkg" || test "`basename $pwd`" != "$pkg"; then
  echo usage: from /data/cashin/opt/foo-x.x.x do $me foo-x.x.x 1>&2
  exit 1
fi

echo "$me: making $pkg files read-only (edit different inode in install dir)"
for f in `find . -type f -perm -0200`; do
    echo $f
    chmod a-w $f
done

echo $me: making directories:
for d in `find . -type d | sed 1d`; do newd=/data/cashin/inst/$d; if test ! -d $newd; then echo $newd; mkdir $newd; fi; done

echo $me: making hard links:
export f; for f in `find . -type f | sed 's/^\.\///'`; do 
  printf "%20s ... " "$f"
  (cd /data/cashin/inst \
   && if test -r $f; then
	inode_inst=`ls -i $f | awk '{ print $1 }'`
	inode_opt=`ls -i ../opt/$pkg/$f | awk '{ print $1 }'`
	if test $inode_inst != $inode_opt; then
	  bkp $f > /dev/null 2>&1 && rm -f $f && ln ../opt/$pkg/$f $f && echo replaced
	else
	  echo "already installed"
	fi
      else 
        ln ../opt/$pkg/$f $f && echo ok
      fi)
done

echo $me: running rsync on non-directory/non-regular-file files:
for f in `find . ! -type d -a ! -type f`; do
    echo rsync -a $f /data/cashin/inst/$f
    rsync -a $f /data/cashin/inst/$f
done

