# uninstall /data/cashin/opt/foo-x.x.x from /data/cashin/inst
# 
# /*
# oinst - software installation management tool
# Copyright (C) 2000, 2001, 2002 Ed L. Cashin
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# */

me=`basename $0`
pwd=`pwd`
pkg=$1
instdir=$2
if test -z "$pkg" || test -z "$instdir" || test "`basename $pwd`" != "$pkg"; then
  echo usage: from /opt/foo-x.x.x do $me foo-x.x.x instdir 1>&2
  exit 1
fi

echo $me: removing hard links:
export f; for f in `find . -type f | sed 's/^\.\///'`; do 
  printf "%20s ... " "$f"
  (cd $instdir \
   && if test -r $f; then
	inode_inst=`ls -i $f | awk '{ print $1 }'`
	inode_opt=`ls -i $pwd/$f | awk '{ print $1 }'`
	if test $inode_inst != $inode_opt; then
	    echo "inode mismatch; skipping."
	else
	    rm -f $f && echo removed.
	fi
      else 
        echo "missing."
      fi)
done

echo $me: removing orphaned symlinks:
for f in `find . ! -type d -a ! -type f`; do
    res="`file $instdir/$f`"
    target="`echo $res | sed 's/.*symbolic link to \(.*\)$/\1/'`"
    if test -z "$target"; then 	# not a symlink
	ls -l $instdir/$f
    elif test ! -r "$target"; then # symlink without target
	echo rm -f $instdir/$f
	rm -f $instdir/$f
    else			# is symlink but still has target
	ls -l $instdir/$f
    fi
done

echo $me: removing empty directories associated with $pkg:
for d in `find . -type d | sed 1d | sort -r`; do
    instd=$instdir/$d
    printf "%20s ... " "$instd"
    if test -d $instd -a `ls -a $instd | wc -l` = 2; then
	echo removing.
	rmdir $instd
    else
	echo skipping.
    fi
done

